// SET LIGHT & DARK MODE STUFF

let is_dark = window.matchMedia && window.matchMedia('(prefers-color-scheme: dark)').matches;

$(".btn-range img").attr("src", is_dark ? "ic_ruler_white.png" : "ic_ruler_black.png");
$(".btn-add img").attr("src", is_dark ? "ic_plus_white.png" : "ic_plus_black.png");
$(".btn-view img").attr("src", is_dark ? "ic_list_white.png" : "ic_list_black.png");
$(".func .edit img").attr("src", is_dark ? "ic_pencil_white.png" : "ic_pencil_black.png");










// DEFAULT PLOT OBJECT

var plot_object = {
	target: "#plot",
	width: document.getElementById("plot").offsetWidth,
	height: document.getElementById("plot").offsetHeight,
	tip: {
		xLine: true,
		yLine: true
	},
	grid: true,
	xAxis: {},
	yAxis: {},
	data: [{
		fnType: "linear",
		sampler: "builtIn",
		graphType: "polyline",
		fn: "sin(x)",
		color: "#0d6efd"
	}]
};

// DEFAULT COLORS

var default_colors = [
	"#00ffff",
	//"#000000",
	"#0000ff",
	"#ff00ff",
	"#808080",
	"#008000",
	"#00ff00",
	"#800000",
	"#000080",
	"#808000",
	"#800080",
	"#ff0000",
	//"#c0c0c0",
	"#008080",
	"#ffff00",
];










// SET AXIS RANGE

$('#apply_range').on('click', function() {
	
	var xmin = $('#axis_range .xmin').val();
	var xmax = $('#axis_range .xmax').val();
	var ymin = $('#axis_range .ymin').val();
	var ymax = $('#axis_range .ymax').val();
	
	var temp_obj = plot_object;
	temp_obj.xAxis.domain = [xmin, xmax];
	temp_obj.yAxis.domain = [ymin, ymax];
	
	functionPlot(plot_object);
	
	$('#axis_range').modal('hide');
	
});










// CREATE NEW FUNCTION

$('#function_type button').on('click', function() {
	
	// HIDE FUNCTION-TYPE MODAL
	
	$('#function_type').modal('hide');
	
	// CLEAR MODAL CONTENT
	
	$('#function_options .modal-body, #function_options .modal-footer').html("");
	
	// BUILD FUNCTION MODAL
	
	var fn_type = $(this).val();
	
	if(fn_type == "linear") {
		$('#function_options .modal-body').html(`
			<div class="row m-0 p-0">
				<div class="col-12 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_fn" class="form-control" placeholder="sin(x)">
						<label for="_fn">Function f(x)</label>
					</div>
				</div>
				<div class="col-6 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_range_min" class="form-control" type="number" placeholder="Min">
						<label for="_range_min">Range Min</label>
					</div>
				</div>
				<div class="col-6 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_range_max" class="form-control" type="number" placeholder="Max">
						<label for="_range_max">Range Max</label>
					</div>
				</div>
			</div>
		`);
	}
	else if(fn_type == "parametric") {
		$('#function_options .modal-body').html(`
			<div class="row m-0 p-0">
				<div class="col-12 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_x" class="form-control" placeholder="cos(t)">
						<label for="_x">Parametric x(t)</label>
					</div>
				</div>
				<div class="col-12 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_y" class="form-control" placeholder="sin(t)">
						<label for="_y">Parametric y(t)</label>
					</div>
				</div>
				<div class="col-6 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_range_min" class="form-control" type="number" placeholder="Min">
						<label for="_range_min">Range Min</label>
					</div>
				</div>
				<div class="col-6 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_range_max" class="form-control" type="number" placeholder="Max">
						<label for="_range_max">Range Max</label>
					</div>
				</div>
			</div>
		`);
	}
	else if(fn_type == "polar") {
		$('#function_options .modal-body').html(`
			<div class="row m-0 p-0">
				<div class="col-12 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_r" class="form-control" placeholder="sin(theta)">
						<label for="_r">Polar r(θ)</label>
					</div>
				</div>
				<div class="col-6 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_range_min" class="form-control" type="number" placeholder="Min">
						<label for="_range_min">Range Min</label>
					</div>
				</div>
				<div class="col-6 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_range_max" class="form-control" type="number" placeholder="Max">
						<label for="_range_max">Range Max</label>
					</div>
				</div>
			</div>
		`);
	}
	else if(fn_type == "implicit") {
		$('#function_options .modal-body').html(`
			<div class="row m-0 p-0">
				<div class="col-12 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_fn" class="form-control" placeholder="x^2 + y^2 - 1">
						<label for="_fn">Implicit</label>
					</div>
				</div>
			</div>
		`);
	}
	else if(fn_type == "points") {
		$('#function_options .modal-body').html(`
			<div class="row m-0 p-0">
				<div class="col-12 m-0 p-0 p-2">
					<div class="form-floating">
						<textarea id="_points" class="form-control" placeholder="1, 2&#13;&#10;3, 4&#13;&#10;" style="height:100px"></textarea>
						<label for="_points">Points</label>
					</div>
				</div>
				<div class="col-12 m-0 p-0 p-2">
					<div class="form-floating">
						<select id="_graph_type" class="form-select">
							<option value="scatter" selected>Points</option>
							<option value="polyline">Lines</option>
						</select>
						<label for="_graph_type">Graph Type</label>
					</div>
				</div>
			</div>
		`);
	}
	
	// BUILD MODAL FOOTER
	
	$('#function_options .modal-footer').html(`
		<div class="row w-100 m-0">
			<div class="col p-0"></div>
			<div class="col p-0">
				<button class="btn_done btn btn-transparent text-success w-100 fw-bold ripple">DONE</button>
			</div>
		</div>
	`);
	
	// ON DONE CLICK
	
	$('#function_options .btn_done').on('click', function() {
		
		var temp_obj = {};
		
		temp_obj.color = default_colors[Math.floor(Math.random() * default_colors.length)];
		
		if(fn_type == "linear") {
			temp_obj.fnType = "linear";
			temp_obj.sampler = "builtIn";
			temp_obj.graphType = "polyline";
			temp_obj.fn = $('#_fn').val();
			if($('#_range_min').val() != "" && $('#_range_max').val() != "")
				temp_obj.range = [parseFloat($('#_range_min').val()), parseFloat($('#_range_max').val())];
		}
		else if(fn_type == "parametric") {
			temp_obj.fnType = "parametric";
			temp_obj.graphType = "polyline";
			temp_obj.x = $('#_x').val();
			temp_obj.y = $('#_y').val();
			if($('#_range_min').val() != "" && $('#_range_max').val() != "")
				temp_obj.range = [parseFloat($('#_range_min').val()), parseFloat($('#_range_max').val())];
		}
		else if(fn_type == "polar") {
			temp_obj.fnType = "polar";
			temp_obj.sampler = "builtIn";
			temp_obj.graphType = "polyline";
			temp_obj.r = $('#_r').val();
			if($('#_range_min').val() != "" && $('#_range_max').val() != "")
				temp_obj.range = [parseFloat($('#_range_min').val()), parseFloat($('#_range_max').val())];
		}
		else if(fn_type == "implicit") {
			temp_obj.fnType = "implicit";
			temp_obj.fn = $('#_fn').val();
		}
		else if(fn_type == "points") {
			temp_obj.fnType = "points";
			temp_obj.sampler = "builtIn";
			temp_obj.graphType = $("#_graph_type option:selected").val();
			temp_obj.points = [];
			var pointsArr = $('#_points').val().replace(/ /g, '').split('\n');
			for(var i = 0; i < pointsArr.length; i++)
				temp_obj.points.push(pointsArr[i].split(',').map(Number));
			for(var i = 0; i < temp_obj.points.length; i++)
				temp_obj.points = temp_obj.points.filter(function(x) { return x.length == 2; });
		}
		
		if(fn_type == "linear") {
			$('#functions_view').append(`
				<div class="func border-bottom">
					<i class="color border add-on" style="background-color:${temp_obj.color}"></i>
					<span class="text">f(x) = ${temp_obj.fn}</span>
					<button class="edit"><img src="${is_dark ? "ic_pencil_white.png" : "ic_pencil_black.png"}"></button>
				</div>
			`);
		}
		else if(fn_type == "parametric") {
			$('#functions_view').append(`
				<div class="func border-bottom">
					<i class="color border add-on" style="background-color:${temp_obj.color}"></i>
					<span class="text">x = ${temp_obj.x}; y = ${temp_obj.y}</span>
					<button class="edit"><img src="${is_dark ? "ic_pencil_white.png" : "ic_pencil_black.png"}"></button>
				</div>
			`);
		}
		else if(fn_type == "polar") {
			$('#functions_view').append(`
				<div class="func border-bottom">
					<i class="color border add-on" style="background-color:${temp_obj.color}"></i>
					<span class="text">r(θ) = ${temp_obj.r}</span>
					<button class="edit"><img src="${is_dark ? "ic_pencil_white.png" : "ic_pencil_black.png"}"></button>
				</div>
			`);
		}
		else if(fn_type == "implicit") {
			$('#functions_view').append(`
				<div class="func border-bottom">
					<i class="color border add-on" style="background-color:${temp_obj.color}"></i>
					<span class="text">0 = ${temp_obj.fn}</span>
					<button class="edit"><img src="${is_dark ? "ic_pencil_white.png" : "ic_pencil_black.png"}"></button>
				</div>
			`);
		}
		else if(fn_type == "points") {
			$('#functions_view').append(`
				<div class="func border-bottom">
					<i class="color border add-on" style="background-color:${temp_obj.color}"></i>
					<span class="text">${JSON.stringify(temp_obj.points).slice(1, -1)}</span>
					<button class="edit"><img src="${is_dark ? "ic_pencil_white.png" : "ic_pencil_black.png"}"></button>
				</div>
			`);
		}
		
		$('#function_options').modal('hide');
		
		plot_object.data.push(temp_obj);
		
		draw();
		
		$('.func').colorpicker({align: 'left', color: temp_obj.color}).on('colorpickerChange', function(e) {
			var index = $('#functions_view .func').index(this);
			plot_object.data[index].color = e.color.toRgbString();
			functionPlot(plot_object);
		});
		
	});
	
	// SHOW FUNCTION-OPTIONS MODAL
	
	$('#function_options').modal('show');
	
});










// DRAW GRAPH

draw();

function draw() {
	plot_object.width  = document.getElementById("plot").offsetWidth;
	plot_object.height = document.getElementById("plot").offsetHeight;
	$('#plot').html("");
	functionPlot(plot_object);
}










// ON-WINDOW-RESIZE LISTENER

var resize_timer;

$(window).resize(function() {
	clearTimeout(resize_timer);
	resize_timer = setTimeout(draw, 100);
});










// SHOW FUNCTIONS

$("#show_functions").on('click', function() {
	
	if($('#functions_view .func').length > 0)
		$('#functions_view').fadeToggle(100);
	else
		$('#functions_view').hide();
	
});










// ON EDIT CLICK

$('#functions_view').on('click', '.func .edit', function() {
	
	// GET OBJECT
	
	var index = $('#functions_view .func').index($(this).parent());
	
	var temp_obj = plot_object.data[index];
	
	// HIDE FUNCTION-TYPE MODAL
	
	$('#function_type').modal('hide');
	
	// CLEAR MODAL CONTENT
	
	$('#function_options .modal-body, #function_options .modal-footer').html("");
	
	// BUILD FUNCTION MODAL
	
	if(temp_obj.fnType == "linear") {
		$('#function_options .modal-body').html(`
			<div class="row m-0 p-0">
				<div class="col-12 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_fn" class="form-control" placeholder="sin(x)" value="${temp_obj.fn}">
						<label for="_fn">Function f(x)</label>
					</div>
				</div>
				<div class="col-6 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_range_min" class="form-control" type="number" placeholder="Min" value="${temp_obj.hasOwnProperty('range') ? temp_obj.range[0] : ''}">
						<label for="_range_min">Range Min</label>
					</div>
				</div>
				<div class="col-6 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_range_max" class="form-control" type="number" placeholder="Max" value="${temp_obj.hasOwnProperty('range') ? temp_obj.range[1] : ''}">
						<label for="_range_max">Range Max</label>
					</div>
				</div>
			</div>
		`);
	}
	else if(temp_obj.fnType == "parametric") {
		$('#function_options .modal-body').html(`
			<div class="row m-0 p-0">
				<div class="col-12 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_x" class="form-control" placeholder="cos(t)" value="${temp_obj.x}">
						<label for="_x">Parametric x(t)</label>
					</div>
				</div>
				<div class="col-12 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_y" class="form-control" placeholder="sin(t)" value="${temp_obj.y}">
						<label for="_y">Parametric y(t)</label>
					</div>
				</div>
				<div class="col-6 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_range_min" class="form-control" type="number" placeholder="Min" value="${temp_obj.hasOwnProperty('range') ? temp_obj.range[0] : ''}">
						<label for="_range_min">Range Min</label>
					</div>
				</div>
				<div class="col-6 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_range_max" class="form-control" type="number" placeholder="Max" value="${temp_obj.hasOwnProperty('range') ? temp_obj.range[1] : ''}">
						<label for="_range_max">Range Max</label>
					</div>
				</div>
			</div>
		`);
	}
	else if(temp_obj.fnType == "polar") {
		$('#function_options .modal-body').html(`
			<div class="row m-0 p-0">
				<div class="col-12 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_r" class="form-control" placeholder="sin(theta)" value="${temp_obj.r}">
						<label for="_r">Polar r(θ)</label>
					</div>
				</div>
				<div class="col-6 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_range_min" class="form-control" type="number" placeholder="Min" value="${temp_obj.hasOwnProperty('range') ? temp_obj.range[0] : ''}">
						<label for="_range_min">Range Min</label>
					</div>
				</div>
				<div class="col-6 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_range_max" class="form-control" type="number" placeholder="Max" value="${temp_obj.hasOwnProperty('range') ? temp_obj.range[1] : ''}">
						<label for="_range_max">Range Max</label>
					</div>
				</div>
			</div>
		`);
	}
	else if(temp_obj.fnType == "implicit") {
		$('#function_options .modal-body').html(`
			<div class="row m-0 p-0">
				<div class="col-12 m-0 p-0 p-2">
					<div class="form-floating">
						<input id="_fn" class="form-control" placeholder="x^2 + y^2 - 1" value="${temp_obj.fn}">
						<label for="_fn">Implicit</label>
					</div>
				</div>
			</div>
		`);
	}
	else if(temp_obj.fnType == "points") {
		var strArr = [];
		for(var x = 0; x < temp_obj.points.length; x++)
			strArr.push(temp_obj.points[x].join(', '));
		var str = strArr.join('\n');
		$('#function_options .modal-body').html(`
			<div class="row m-0 p-0">
				<div class="col-12 m-0 p-0 p-2">
					<div class="form-floating">
						<textarea id="_points" class="form-control" placeholder="1, 2&#13;&#10;3, 4&#13;&#10;" style="height:100px">${str}</textarea>
						<label for="_points">Points</label>
					</div>
				</div>
				<div class="col-12 m-0 p-0 p-2">
					<div class="form-floating">
						<select id="_graph_type" class="form-select">
                            <option value="scatter" ${temp_obj.graphType != 'polyline' ? 'selected' : ''}>Points</option>
                            <option value="polyline" ${temp_obj.graphType == 'polyline' ? 'selected' : ''}>Lines</option>
						</select>
						<label for="_graph_type">Graph Type</label>
					</div>
				</div>
			</div>
		`);
	}
	
	// BUILD MODAL FOOTER
	
	$('#function_options .modal-footer').html(`
		<div class="row w-100 m-0">
			<div class="col p-0">
				<button class="btn_delete btn btn-transparent text-danger w-100 fw-bold ripple">DELETE</button>
			</div>
			<div class="col p-0">
				<button class="btn_done btn btn-transparent text-success w-100 fw-bold ripple">DONE</button>
			</div>
		</div>
	`);
	
	// ON DELETE CLICK
	
	$('#function_options .btn_delete').on('click', function() {

		plot_object.data.splice(index, 1);
		
		$('#functions_view .func').eq(index).remove();
		
		if($('#functions_view .func').length == 0)
			$('#functions_view').hide();
		
		$('#function_options').modal('hide');
		
		draw();
		
	});
	
	// ON DONE CLICK
	
	$('#function_options .btn_done').on('click', function() {
		
		if(temp_obj.fnType == "linear") {
			plot_object.data[index].fn = $('#_fn').val();
			if($('#_range_min').val() != "" && $('#_range_max').val() != "")
				plot_object.data[index].range = [parseFloat($('#_range_min').val()), parseFloat($('#_range_max').val())];
			else
				delete plot_object.data[index].range;
		}
		else if(temp_obj.fnType == "parametric") {
			plot_object.data[index].x = $('#_x').val();
			plot_object.data[index].y = $('#_y').val();
			if($('#_range_min').val() != "" && $('#_range_max').val() != "")
				plot_object.data[index].range = [parseFloat($('#_range_min').val()), parseFloat($('#_range_max').val())];
			else
				delete plot_object.data[index].range;
		}
		else if(temp_obj.fnType == "polar") {
			plot_object.data[index].r = $('#_r').val();
			if($('#_range_min').val() != "" && $('#_range_max').val() != "")
				plot_object.data[index].range = [parseFloat($('#_range_min').val()), parseFloat($('#_range_max').val())];
			else
				delete plot_object.data[index].range;
		}
		else if(temp_obj.fnType == "implicit") {
			plot_object.data[index].fn = $('#_fn').val();
		}
		else if(temp_obj.fnType == "points") {
			plot_object.data[index].graphType = $("#_graph_type option:selected").val();
			plot_object.data[index].points = [];
			var pointsArr = $('#_points').val().replace(/ /g, '').split('\n');
			for(var i = 0; i < pointsArr.length; i++)
				plot_object.data[index].points.push(pointsArr[i].split(',').map(Number));
			for(var i = 0; i < plot_object.data[index].points.length; i++)
				plot_object.data[index].points = plot_object.data[index].points.filter(function(x) { return x.length == 2; });
		}
		
		if(temp_obj.fnType == "linear")
			$('#functions_view .func').eq(index).find('.text').text(`f(x) = ${plot_object.data[index].fn}`);
		else if(temp_obj.fnType == "parametric")
			$('#functions_view .func').eq(index).find('.text').text(`x = ${plot_object.data[index].x}; y = ${plot_object.data[index].y}`);
		else if(temp_obj.fnType == "polar")
			$('#functions_view .func').eq(index).find('.text').text(`r(θ) = ${plot_object.data[index].r}`);
		else if(temp_obj.fnType == "implicit")
			$('#functions_view .func').eq(index).find('.text').text(plot_object.data[index].fn);
		else if(temp_obj.fnType == "points")
			$('#functions_view .func').eq(index).find('.text').text(JSON.stringify(plot_object.data[index].points).slice(1, -1));
		
		$('#function_options').modal('hide');
		
		draw();
		
	});
	
	// SHOW FUNCTION-OPTIONS MODAL

	$('#function_options').modal('show');
	
});










// ON COLOR CLICK

$('.func').colorpicker({align: 'left', color: '#0d6efd'}).on('colorpickerChange', function(e) {
	var index = $('#functions_view .func').index(this);
	plot_object.data[index].color = e.color.toRgbString();
	functionPlot(plot_object);
});
